#==============================================================================#
# MyClasses.R:            contains all class definitions and method definitions
# methods.BaseClass.R:    contains methods for BaseClass
# methods.SubClassA.R:    contains methods for SubClassA
# methods.SubClassB.R:    contains methods for SubClassB
# methods.SubSubClassA.R: contains methods for SubSubClassA
# methods.SubSubClassB.R: contains methods for SubSubClassB
#==============================================================================#


#------------------------------------------------------------------------------#
# BaseClass: virtual superset for 'SubClassA', 'SubSubClassA' etc
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

# class BaseClass
setClass("BaseClass",
   representation(filename  = "character",
                  filedir   = "character",
                  dirfile   = "character",
                  "VIRTUAL"
#                  dirfile   = "character"
   ),

#   contains=c("list"),

#   prototype(filename  = "DefaultFileName",
   prototype(filename  = character(),
             filedir   = as.character(getwd()),
             dirfile   = ""
   )
)#BaseClass

# generics for class BaseClass
setGeneric("dirFile",    function(object) standardGeneric("dirFile"));
setGeneric("dirFile<-",  function(object, value) standardGeneric("dirFile<-"));
setGeneric("fileName",   function(object) standardGeneric("fileName"));
setGeneric("fileName<-", function(object, value) standardGeneric("fileName<-"));
setGeneric("mymethod",   function(object,...) standardGeneric("mymethod"));


#------------------------------------------------------------------------------#
# SubClassA: 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setClass("SubClassA",
   representation(myname  = "character",
                  mytitle = "character"
   ),

   contains=c("BaseClass"),

   prototype(myname  = "",
             mytitle = "MyTitle"
   )
)#SubClassA

# generics for class SubClassA
setGeneric("myName",    function(object) standardGeneric("myName"));
setGeneric("myTitle",   function(object) standardGeneric("myTitle"));
setGeneric("myTitle<-", function(object, value) standardGeneric("myTitle<-"));


#------------------------------------------------------------------------------#
# SubClassB: 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setClass("SubClassB",
   representation(subA = "SubClassA",
                  data = "data.frame"
   ),

   contains=c("BaseClass"),

   prototype(subA = new("SubClassA"),
#             data = new( "data.frame")
             data = data.frame(matrix(nr=0,nc=0))
   )
)#SubClassB

# generics for class SubClassB
setGeneric("subNameA", function(object) standardGeneric("subNameA"));


#------------------------------------------------------------------------------#
# SubSubClassA: 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setClass("SubSubClassA",
   contains=c("SubClassB")
)#SubSubClassA

# generics for class SubSubClassA
setGeneric("myFrameA",   function(object) standardGeneric("myFrameA"));
setGeneric("myFrameA<-", function(object, value) standardGeneric("myFrameA<-"));
setGeneric("methodsubsubB", function(object,...) standardGeneric("methodsubsubB"));



#------------------------------------------------------------------------------#
# SubSubClassB: 
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setClass("SubSubClassB",
   representation(subsubnameB = "character"),

   contains=c("SubClassB"),

   prototype(subsubnameB = "MySubSubB")
)#SubSubClassB

# generics for class SubSubClassB
setGeneric("myFrameB",   function(object) standardGeneric("myFrameB"));
setGeneric("myFrameB<-", function(object, value) standardGeneric("myFrameB<-"));



#------------------------------------------------------------------------------#

#####
# tar czf myclasspkg_0.1.1.tar.gz myclasspkg
# R CMD INSTALL -l ~/Library/R/library myclasspkg_0.1.1.tar.gz
#####



