#==============================================================================#
# class BaseClass: initialization, accessors, methods
#==============================================================================#


#------------------------------------------------------------------------------#
# BaseClass initialization:
#------------------------------------------------------------------------------#

"initialize.BaseClass" <-
#function(.Object, filename=character(0), filedir=as.character(getwd()), dirfile=character(0), ...) {
function(.Object, filename=character(), filedir=as.character(getwd()), dirfile=character(), ...) {
   print("------initialize:BaseClass------")
print(paste("BaseClass:init:class(.Object) = ", class(.Object)))

#callNextMethod();
#   .Object <- callNextMethod(.Object, ...);

   dirfile <- pathFile(filename, filedir);
print(paste("BaseClass:init:dirfile = ", dirfile))

   .Object <- callNextMethod(.Object, filename=filename, filedir=filedir, dirfile=dirfile, ...);

   .Object@filename <- filename;
   .Object@filedir  <- filedir;
   .Object@dirfile  <- dirfile;
   .Object;
}#initialize.BaseClass

setMethod("initialize", "BaseClass", initialize.BaseClass);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("BaseClass",
   function(object) {
      print("------setValidity:BaseClass------")
print(paste("BaseClass:val:class(object) = ", class(object)))
      msg <- NULL;

      strg <- dirname(object@dirfile);
      if (!(is(strg, "character"))) {
#      if (!(is(strg, "character") && file.exists(strg))) {
         msg <- validMsg(msg,
                         paste(sQuote("filedir"), "is not a system directory"));
      }#if
print(paste("BaseClass:val:dirfile = ",object@dirfile))

      ## check for presence of directory for file
      strg <- object@filedir;
      if (!(is(strg, "character"))) {
#      if (is.na(file.dir(strg))) {
         msg <- validMsg(msg,
                         paste(sQuote("filedir"), "is not a system directory"));
      }#if
print(paste("BaseClass:val:filedir = ",object@filedir))

      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#------------------------------------------------------------------------------#
# BaseClass accessors:
#------------------------------------------------------------------------------#

setMethod("fileName", signature(object="BaseClass"),
   function(object) object@filename
)#fileName

setReplaceMethod("fileName", signature(object="BaseClass", value="character"),
   function(object, value) {
      object@filename <- value;
      return(object);
   }
)#fileName<-

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setMethod("dirFile", signature(object="BaseClass"),
   function(object) object@dirfile
)#dirFile

setReplaceMethod("dirFile", signature(object="BaseClass", value="character"),
   function(object, value) {
      object@dirfile <- value;
      return(object);
   }
)#dirFile<-


#------------------------------------------------------------------------------#
# BaseClass methods:
#------------------------------------------------------------------------------#

"mymethod.BaseClass" <-
function(object, ...) {
   print("------mymethod.BaseClass------")

   ## check for presence of file
   dirfile <- validPathFile(dirFile(object));
print(paste("BaseClass:mymethod:dirfile = ",dirfile))

}#mymethod.BaseClass

setMethod("mymethod", "BaseClass", mymethod.BaseClass);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -




