#==============================================================================#
# class SubClassA: initialization, accessors, methods
#==============================================================================#


#------------------------------------------------------------------------------#
# SubClassA initialization:
#------------------------------------------------------------------------------#

"initialize.SubClassA" <-
function(.Object, myname="MyName", mytitle="MyTitle", ...) {
   print("------initialize:SubClassA------")
print(paste("SubClassA:init:class(.Object) = ", class(.Object)))

#   .Object <- callNextMethod(.Object, ...);

   ## set default myname
   if (myname == "") {
      myname <- "DefaultName";
   }#if
print(paste("SubClassA:init:myname = ", myname))

   ## set default mytitle
   if (mytitle == "") {
      mytitle <- "DefaultTitle";
   }#if
print(paste("SubClassA:init:mytitle = ", mytitle))

   .Object <- callNextMethod(.Object, myname=myname, mytitle=mytitle, ...);

   .Object@myname <- myname;
   .Object@mytitle <- mytitle;
   .Object;
}#initialize.SubClassA

setMethod("initialize", "SubClassA", initialize.SubClassA);

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setValidity("SubClassA",
   function(object) {
      print("------setValidity:SubClassA------")
print(paste("SubClassA:val:class(object) = ", class(object)))
      msg <- NULL;

      ## check myname
      strg <- object@myname;
      if (!(is(strg, "character") && nchar(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("myname"), "is missing"));
      }#if
print(paste("SubClassA:val:myname = ",object@myname))

      ## check mytitle
      strg <- object@mytitle;
      if (!(is(strg, "character") && nchar(strg) > 0)) {
         msg <- validMsg(msg, paste(sQuote("mytitle"), "is missing"));
      }#if
print(paste("SubClassA:val:mytitle = ",object@mytitle))

      if (is.null(msg)) TRUE else msg;
   }
)#setValidity


#------------------------------------------------------------------------------#
# SubClassA accessors:
#------------------------------------------------------------------------------#

setMethod("myName", signature(object="SubClassA"),
   function(object) object@myname
)#myName

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

setMethod("myTitle", signature(object="SubClassA"),
   function(object) object@mytitle
)#myTitle

setReplaceMethod("myTitle", signature(object="SubClassA", value="character"),
   function(object, value) {
      object@mytitle <- value;
      return(object);
   }
)#myTitle<-


#------------------------------------------------------------------------------#
# SubClassA methods:
#------------------------------------------------------------------------------#

"mymethod.SubClassA" <-
function(object, filename=character(0), filedir=character(0), ...) {
   print("------mymethod.SubClassA------")

   callNextMethod();

   ## create file in directory filedir
   dirfile <- pathFile(filename, filedir);
print(paste("SubClassA:mymethod:dirfile = ",dirfile))

   ds <- data.frame(cbind(x=1, y=1:10));
   write.table(ds, dirfile);

   dirFile(object) <- dirfile;
#   object@dirfile <- dirfile;
   return(object);
}#mymethod.SubClassA

setMethod("mymethod", "SubClassA", mymethod.SubClassA);


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
